diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java b/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
index 2028ff1f4..78d293c46 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
@@ -1,10 +1,9 @@
 package net.minecraft.core.world.generate.chunk.classic;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
-import net.minecraft.core.world.generate.MapGenCaves;
+import net.minecraft.core.world.generate.CavesLargeFeature;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
 import net.minecraft.core.world.generate.chunk.perlin.SurfaceGenerator;
@@ -24,7 +23,7 @@ public class ChunkGeneratorClassic
     private final PerlinNoise octavesB;
 
     private final SurfaceGenerator sg;
-    private final MapGenCaves cg;
+    private final CavesLargeFeature cg;
 
     public ChunkGeneratorClassic(World world)
     {
@@ -40,7 +39,7 @@ public class ChunkGeneratorClassic
         octavesB = new PerlinNoise(seed, 8, 70);
 
         sg = new SurfaceGeneratorOverworldRetro(world);
-        cg = new MapGenCaves(true);
+        cg = new CavesLargeFeature();
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/indev/ChunkGeneratorIndev.java b/src/main/java/net/minecraft/core/world/generate/chunk/indev/ChunkGeneratorIndev.java
index 0fed457a1..83aaa3447 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/indev/ChunkGeneratorIndev.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/indev/ChunkGeneratorIndev.java
@@ -1,10 +1,9 @@
 package net.minecraft.core.world.generate.chunk.indev;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
-import net.minecraft.core.world.generate.MapGenCaves;
+import net.minecraft.core.world.generate.CavesLargeFeature;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
 import net.minecraft.core.world.generate.chunk.perlin.SurfaceGenerator;
@@ -16,7 +15,7 @@ public class ChunkGeneratorIndev
 {
     private final LevelGenerator lg;
     private final SurfaceGenerator sg;
-    private final MapGenCaves cg;
+    private final CavesLargeFeature cg;
 
     public ChunkGeneratorIndev(World world, int sizeX, int sizeY, int sizeZ, IndevWorldType worldType, IndevWorldTheme worldTheme)
     {
@@ -24,7 +23,7 @@ public class ChunkGeneratorIndev
 
         lg = new LevelGenerator(sizeX, sizeY, sizeZ, worldType, worldTheme);
         sg = new SurfaceGeneratorOverworldRetro(world);
-        cg = new MapGenCaves(true);
+        cg = new CavesLargeFeature();
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/ChunkGeneratorPerlin.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/ChunkGeneratorPerlin.java
index 8480755cf..da5c5d75c 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/ChunkGeneratorPerlin.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/ChunkGeneratorPerlin.java
@@ -2,11 +2,14 @@ package net.minecraft.core.world.generate.chunk.perlin;
 
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
-import net.minecraft.core.world.generate.MapGenBase;
+import net.minecraft.core.world.generate.LargeFeature;
 import net.minecraft.core.world.generate.chunk.ChunkDecorator;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
 
+import java.util.Arrays;
+import java.util.List;
+
 /**
  * This class provides basic functionality to generate a {@link Chunk chunk} using 3-dimensional Perlin noise.
  */
@@ -15,15 +18,15 @@ public class ChunkGeneratorPerlin
 {
     private final TerrainGenerator terrainGenerator;
     private final SurfaceGenerator surfaceGenerator;
-    private final MapGenBase cavesGenerator;
+    private final List<LargeFeature> largeFeatures;
 
-    protected ChunkGeneratorPerlin(World world, ChunkDecorator decorator, TerrainGenerator terrainGenerator, SurfaceGenerator surfaceGenerator, MapGenBase cavesGenerator)
+    protected ChunkGeneratorPerlin(World world, ChunkDecorator decorator, TerrainGenerator terrainGenerator, SurfaceGenerator surfaceGenerator, LargeFeature[] largeFeatures)
     {
         super(world, decorator);
 
         this.terrainGenerator = terrainGenerator;
         this.surfaceGenerator = surfaceGenerator;
-        this.cavesGenerator = cavesGenerator;
+        this.largeFeatures = Arrays.asList(largeFeatures);
     }
 
     @Override
@@ -32,7 +35,9 @@ public class ChunkGeneratorPerlin
         double[] densityMap = terrainGenerator.getDensityGenerator().generateDensityMap(chunk);
         ChunkGeneratorResult result = terrainGenerator.generateTerrain(chunk, densityMap);
         surfaceGenerator.generateSurface(chunk, result);
-        cavesGenerator.generate(world, chunk.xPosition, chunk.zPosition, result);
+        for (LargeFeature largeFeature : largeFeatures) {
+            largeFeature.generate(world, chunk.xPosition, chunk.zPosition, result);
+        }
 
         return result;
     }
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkGeneratorNether.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkGeneratorNether.java
index c663ee506..df70b1d23 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkGeneratorNether.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkGeneratorNether.java
@@ -1,18 +1,16 @@
 package net.minecraft.core.world.generate.chunk.perlin.nether;
 
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.generate.MapGenCavesHell;
+import net.minecraft.core.world.generate.CavesLargeFeature;
+import net.minecraft.core.world.generate.LargeFeature;
+import net.minecraft.core.world.generate.WarrensCavesLargeFeature;
 import net.minecraft.core.world.generate.chunk.perlin.ChunkGeneratorPerlin;
-import net.minecraft.core.world.generate.chunk.perlin.DensityGenerator;
-import net.minecraft.core.world.generate.chunk.perlin.SurfaceGenerator;
-import net.minecraft.core.world.generate.chunk.perlin.TerrainGenerator;
-import net.minecraft.core.world.generate.chunk.perlin.overworld.TerrainGeneratorOverworld;
 
 public class ChunkGeneratorNether
     extends ChunkGeneratorPerlin
 {
     public ChunkGeneratorNether(World world)
     {
-        super(world, new ChunkDecoratorNether(world), new TerrainGeneratorNether(world), new SurfaceGeneratorNether(world), new MapGenCavesHell());
+        super(world, new ChunkDecoratorNether(world), new TerrainGeneratorNether(world), new SurfaceGeneratorNether(world), new LargeFeature[] { new CavesLargeFeature(128, 256), new WarrensCavesLargeFeature(0, 128) });
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
index 0a902d2de..b7b17333d 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
@@ -23,20 +23,29 @@ public class TerrainGeneratorNether
     protected int getBlockAt(int x, int y, int z, double density)
     {
         WorldType type = world.getWorldType();
+        int halfHeight = type.getMaxY() / 2;
 
         if (y >= type.getMaxY() - rand.nextInt(5))
         {
             return Blocks.BEDROCK.id;
         }
+        else if (y >= halfHeight - rand.nextInt(5) && y <= halfHeight + 5 - rand.nextInt(5))
+        {
+            return Blocks.BONESHALE.id;
+        }
         else if (y <= type.getMinY() + rand.nextInt(5))
         {
             return Blocks.BEDROCK.id;
         }
+        else if (y <= halfHeight)
+        {
+            return Blocks.SOULSCHIST.id;
+        }
         else if (density > 0.0)
         {
             return type.getFillerBlockId();
         }
-        else if (y >= type.getMinY() && y < type.getMinY() + type.getOceanY())
+        else if (y >= halfHeight && y < type.getOceanY())
         {
             return type.getOceanBlockId();
         }
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkGeneratorOverworld.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkGeneratorOverworld.java
index 374c64227..fc86a3ab8 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkGeneratorOverworld.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkGeneratorOverworld.java
@@ -1,7 +1,8 @@
 package net.minecraft.core.world.generate.chunk.perlin.overworld;
 
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.generate.MapGenCaves;
+import net.minecraft.core.world.generate.CavesLargeFeature;
+import net.minecraft.core.world.generate.LargeFeature;
 import net.minecraft.core.world.generate.chunk.perlin.ChunkGeneratorPerlin;
 
 public class ChunkGeneratorOverworld
@@ -9,6 +10,6 @@ public class ChunkGeneratorOverworld
 {
     public ChunkGeneratorOverworld(World world)
     {
-        super(world, new ChunkDecoratorOverworld(world), new TerrainGeneratorOverworld(world), new SurfaceGeneratorOverworld(world), new MapGenCaves(false));
+        super(world, new ChunkDecoratorOverworld(world), new TerrainGeneratorOverworld(world), new SurfaceGeneratorOverworld(world), new LargeFeature[] { new CavesLargeFeature() });
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/floating/ChunkGeneratorOverworldFloating.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/floating/ChunkGeneratorOverworldFloating.java
index 13a916bb6..290bd0d8f 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/floating/ChunkGeneratorOverworldFloating.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/floating/ChunkGeneratorOverworldFloating.java
@@ -1,12 +1,9 @@
 package net.minecraft.core.world.generate.chunk.perlin.overworld.floating;
 
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.generate.MapGenBase;
-import net.minecraft.core.world.generate.MapGenCaves;
-import net.minecraft.core.world.generate.chunk.ChunkDecorator;
+import net.minecraft.core.world.generate.CavesLargeFeature;
+import net.minecraft.core.world.generate.LargeFeature;
 import net.minecraft.core.world.generate.chunk.perlin.ChunkGeneratorPerlin;
-import net.minecraft.core.world.generate.chunk.perlin.SurfaceGenerator;
-import net.minecraft.core.world.generate.chunk.perlin.TerrainGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.ChunkDecoratorOverworld;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.SurfaceGeneratorOverworld;
 import net.minecraft.core.world.generate.chunk.perlin.paradise.TerrainGeneratorParadise;
@@ -16,6 +13,6 @@ public class ChunkGeneratorOverworldFloating
 {
     public ChunkGeneratorOverworldFloating(World world)
     {
-        super(world, new ChunkDecoratorOverworld(world), new TerrainGeneratorParadise(world), new SurfaceGeneratorOverworld(world), new MapGenCaves(false));
+        super(world, new ChunkDecoratorOverworld(world), new TerrainGeneratorParadise(world), new SurfaceGeneratorOverworld(world), new LargeFeature[] { new CavesLargeFeature() });
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkGeneratorOverworldHell.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkGeneratorOverworldHell.java
index 9896fc84c..2aba0f926 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkGeneratorOverworldHell.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkGeneratorOverworldHell.java
@@ -1,13 +1,9 @@
 package net.minecraft.core.world.generate.chunk.perlin.overworld.hell;
 
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.generate.MapGenBase;
-import net.minecraft.core.world.generate.MapGenCaves;
-import net.minecraft.core.world.generate.chunk.ChunkDecorator;
-import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import net.minecraft.core.world.generate.CavesLargeFeature;
+import net.minecraft.core.world.generate.LargeFeature;
 import net.minecraft.core.world.generate.chunk.perlin.ChunkGeneratorPerlin;
-import net.minecraft.core.world.generate.chunk.perlin.SurfaceGenerator;
-import net.minecraft.core.world.generate.chunk.perlin.TerrainGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.SurfaceGeneratorOverworld;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.TerrainGeneratorOverworld;
 
@@ -17,6 +13,6 @@ public class ChunkGeneratorOverworldHell
 
     public ChunkGeneratorOverworldHell(World world)
     {
-        super(world, new ChunkDecoratorOverworldHell(world), new TerrainGeneratorOverworld(world), new SurfaceGeneratorOverworld(world), new MapGenCaves(false));
+        super(world, new ChunkDecoratorOverworldHell(world), new TerrainGeneratorOverworld(world), new SurfaceGeneratorOverworld(world), new LargeFeature[] { new CavesLargeFeature() });
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkGeneratorOverworldRetro.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkGeneratorOverworldRetro.java
index 503aba5cc..118166f8b 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkGeneratorOverworldRetro.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkGeneratorOverworldRetro.java
@@ -1,13 +1,9 @@
 package net.minecraft.core.world.generate.chunk.perlin.overworld.retro;
 
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.generate.MapGenBase;
-import net.minecraft.core.world.generate.MapGenCaves;
-import net.minecraft.core.world.generate.chunk.ChunkDecorator;
+import net.minecraft.core.world.generate.CavesLargeFeature;
+import net.minecraft.core.world.generate.LargeFeature;
 import net.minecraft.core.world.generate.chunk.perlin.ChunkGeneratorPerlin;
-import net.minecraft.core.world.generate.chunk.perlin.SurfaceGenerator;
-import net.minecraft.core.world.generate.chunk.perlin.TerrainGenerator;
-import net.minecraft.core.world.generate.chunk.perlin.overworld.TerrainGeneratorOverworld;
 
 public class ChunkGeneratorOverworldRetro
     extends ChunkGeneratorPerlin
@@ -19,7 +15,7 @@ public class ChunkGeneratorOverworldRetro
               new ChunkDecoratorOverworldRetro(world),
               new TerrainGeneratorOverworldRetro(world),
               new SurfaceGeneratorOverworldRetro(world),
-              new MapGenCaves(true)
+              new LargeFeature[] { new CavesLargeFeature() }
         );
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/woods/ChunkGeneratorOverworldWoods.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/woods/ChunkGeneratorOverworldWoods.java
index eb6935279..0014d4d9a 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/woods/ChunkGeneratorOverworldWoods.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/woods/ChunkGeneratorOverworldWoods.java
@@ -1,7 +1,8 @@
 package net.minecraft.core.world.generate.chunk.perlin.overworld.woods;
 
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.generate.MapGenCaves;
+import net.minecraft.core.world.generate.CavesLargeFeature;
+import net.minecraft.core.world.generate.LargeFeature;
 import net.minecraft.core.world.generate.chunk.perlin.ChunkGeneratorPerlin;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.SurfaceGeneratorOverworld;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.TerrainGeneratorOverworld;
@@ -11,6 +12,6 @@ public class ChunkGeneratorOverworldWoods
 {
     public ChunkGeneratorOverworldWoods(World world)
     {
-        super(world, new ChunkDecoratorOverworldWoods(world), new TerrainGeneratorOverworld(world), new SurfaceGeneratorOverworld(world), new MapGenCaves(false));
+        super(world, new ChunkDecoratorOverworldWoods(world), new TerrainGeneratorOverworld(world), new SurfaceGeneratorOverworld(world), new LargeFeature[] { new CavesLargeFeature() });
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/paradise/ChunkGeneratorParadise.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/paradise/ChunkGeneratorParadise.java
index c91bc7a6e..dc967fac1 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/paradise/ChunkGeneratorParadise.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/paradise/ChunkGeneratorParadise.java
@@ -1,7 +1,8 @@
 package net.minecraft.core.world.generate.chunk.perlin.paradise;
 
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.generate.MapGenCaves;
+import net.minecraft.core.world.generate.CavesLargeFeature;
+import net.minecraft.core.world.generate.LargeFeature;
 import net.minecraft.core.world.generate.chunk.perlin.ChunkGeneratorPerlin;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.ChunkDecoratorOverworld;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.SurfaceGeneratorOverworld;
@@ -11,6 +12,6 @@ public class ChunkGeneratorParadise
 {
     public ChunkGeneratorParadise(World world)
     {
-        super(world, new ChunkDecoratorOverworld(world), new TerrainGeneratorParadise(world), new SurfaceGeneratorOverworld(world), new MapGenCaves(false));
+        super(world, new ChunkDecoratorOverworld(world), new TerrainGeneratorParadise(world), new SurfaceGeneratorOverworld(world), new LargeFeature[] { new CavesLargeFeature() });
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java b/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
index 118103f9a..bd3849c11 100644
--- a/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
+++ b/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
@@ -26,7 +26,7 @@ public class WorldTypeNether
                 .noClouds()
                 .noSky()
                 .withCeiling()
-                .bounds(128, 255, 32);
+                .bounds(0, 255, 128 + 32);
     }
 
     private static float[] getLightRamp() {
diff --git a/src/main/java/net/minecraft/server/world/ServerPlayerController.java b/src/main/java/net/minecraft/server/world/ServerPlayerController.java
index 7bfd0f723..b94708763 100644
--- a/src/main/java/net/minecraft/server/world/ServerPlayerController.java
+++ b/src/main/java/net/minecraft/server/world/ServerPlayerController.java
@@ -35,7 +35,7 @@ public class ServerPlayerController
             if(j != 0)
             {
                 Block block = Block.blocksList[j];
-                float f = block.blockStrength(player) * (float)(i + 1);
+                float f = block.blockStrength(thisWorld, destroyX, destroyY, destroyZ, destroySide, player) * (float)(i + 1);
                 if(f >= 1.0F)
                 {
                     destroyBlock = false;
@@ -55,7 +55,7 @@ public class ServerPlayerController
 		}
 		blockHitTicks = ticksRan;
 		Block block = thisWorld.getBlock(x, y, z);
-		if(block != null && block.blockStrength(player) >= 1.0F) {
+		if(block != null && block.blockStrength(thisWorld, x, y, z, side, player) >= 1.0F) {
 			mineBlock(x, y, z, side);
 		} else {
 			currentlyMiningX = x;
@@ -81,7 +81,7 @@ public class ServerPlayerController
             if(i1 != 0)
             {
                 Block block = Block.blocksList[i1];
-                float f = block.blockStrength(player) * (float)(l + 1);
+                float f = block.blockStrength(thisWorld, x, y, z, side, player) * (float)(l + 1);
                 if(f >= 0.7F)
                 {
                     return mineBlock(x, y, z, side);
